from linebot import LineBotApi
from linebot.exceptions import LineBotApiError
from linebot import WebhookHandler
from linebot.models import MessageEvent, TextMessage, TextSendMessage, FlexSendMessage, PostbackEvent
from flask import Flask, request
import json
import schedule
import datetime
import time
import subprocess

app = Flask(__name__)

# LINEアクセストークン
line_bot_api = LineBotApi('z9N6X7ySHVj/HcmVhGzqe/VyyC7iM6BU70gARZ5QMZOrGM0weUcqmBG4Rw6bjwh4CypqodRbNyy/on72ajiKKcTs61OaVEpXhAPGkM2MvyRLmCUibqcWzmFAjbJdyG7mB+Re26bN7Q3XMQ1GkpbizwdB04t89/1O/w1cDnyilFU=')

# LINE Botのチャネルシークレットとアクセストークン
CHANNEL_SECRET = 'd959e7217e7d358f8ee7c5977759c262'
CHANNEL_ACCESS_TOKEN = 'z9N6X7ySHVj/HcmVhGzqe/VyyC7iM6BU70gARZ5QMZOrGM0weUcqmBG4Rw6bjwh4CypqodRbNyy/on72ajiKKcTs61OaVEpXhAPGkM2MvyRLmCUibqcWzmFAjbJdyG7mB+Re26bN7Q3XMQ1GkpbizwdB04t89/1O/w1cDnyilFU='

# Webhookハンドラを初期化
handler = WebhookHandler(CHANNEL_SECRET)

# 送信先のユーザーID（LINE ID）
user_id = 'Uf717e182d6d88171538fdec28d740105'



flex_message_json = {
  "type": "bubble",
  "body": {
    "type": "box",
    "layout": "baseline",
    "contents": [
      {
        "type": "text",
        "text": "日時設定",
        "weight": "bold",
        "size": "xl"
      }
    ]
  },
  "footer": {
    "type": "box",
    "layout": "vertical",
    "spacing": "sm",
    "contents": [
      {
        "type": "button",
        "style": "link",
        "height": "sm",
        "action": {
          "type": "datetimepicker",
          "label": "日時選択",
          "data": "datetime_picker_data",
          "mode": "datetime"
        }
      },
      {
        "type": "box",
        "layout": "vertical",
        "contents": [],
        "margin": "sm"
      }
    ],
    "flex": 0
  }
}

@app.route("/callback", methods=['POST'])
def callback():
    signature = request.headers['X-Line-Signature']

    body = request.get_data(as_text=True)
    app.logger.info("Request body: " + body)

    try:
        handler.handle(body, signature)
    except Exception as e:
        app.logger.error("Error: " + str(e))
        return 'OK'

    return 'OK'


@handler.add(MessageEvent, message=TextMessage)
def handle_message(event):
    message_text = event.message.text
        #ここから条件
    
    
    if (message_text == '時間設定'):

        # Flex Messageのインスタンスを作成
        flex_message = FlexSendMessage(alt_text="日時を選択してください", contents=flex_message_json)

        # ユーザーにFlex Messageを送信
        try:
            line_bot_api.push_message(user_id, flex_message)
        except LineBotApiError as e:
            print(e)

    
@handler.add(PostbackEvent)
def on_postback(event):
    del_mes = "T"
    rem_mes = "-"
    postback_msg = event.postback.params['datetime']

    message_back=TextSendMessage(text="日時が選択されました。"+ postback_msg)
    
    # 文字列から特定の文字を削除する
    mes_del = postback_msg.replace(del_mes,  " ")
    mes_rem = mes_del.replace(rem_mes,  "/")
    print(mes_rem)

    try:
        # メッセージを送信
        line_bot_api.push_message(user_id,message_back)
        print('メッセージを送信しました。')
    except LineBotApiError as e:
        print('メッセージの送信に失敗しました。エラー: ' + str(e))
    
    start_time = datetime.datetime.strptime(mes_rem, '%Y/%m/%d %H:%M')
    time_second = (start_time - datetime.datetime.now()).seconds
    time.sleep(time_second)
    print("now on!")
    on=True
    if(on == True):
        subprocess.Popen("./mirs/pilot")
if __name__ == "__main__":
    app.run()